/*
 * TUNA-CAN' g[NX[R[h Visual DSP++p
 *
 * Copyright(C) 2014 Shinya Kaneko
 *
 * Last Update: 2014/11/01
 *
 * []
 * ̃\tgEFA̓t[\tgEFAłBǂȂłRɉςĎgp邱Ƃł܂B
 * ̃\tgEFA͖ۏ؂łB̃\tgEFA̎gpɋNA[U܂͑O҂
 * QɊւA؂̐ӔC𕉂܂B
 *
 * [NOTE]
 * This program is free software, you can redistribute it and/or modify it.
 * There is no warranty for this free software.
 *
 */
  
#include <blackfin.h>
#include <builtins.h>
#include <sys/exception.h>
#include <stdint.h>
#include <string.h>

/* RANbN(396MHz) */
#define CCLOCK_HZ		(396000000)
/* VXeNbN(99MHz) */
#define SCLOCK_HZ		(99000000)
/* {[[g(115200bps) */
#define UART0_BAUDRATE	(57600)
/* UART0_DLL/UART0_DLH̐ݒl */
#define UART0_DIVISOR	(SCLOCK_HZ/16/UART0_BAUDRATE)

#define TWI_COUNT(x) (DCNT & ((x) << 6))
/* TWIp߂l */
#define NO_ERROR		(0)
#define TWI_ERROR_NAK	(-1)
/* s_twi_master_writerstartp` */
#define TWI_STOP		(0)
#define TWI_RSTART		(1)

/* SSM2603I2CfoCXAhX */
#define TWI_CODEC_DEVICE_ADDR	(0x1A)

/* 1̃TvTCY */
#define NUM_SAMPLES		(256)

/* SPORT RX DMA荞݂̃vg^Cv錾 */
EX_INTERRUPT_HANDLER(s_sport_rx_isr);
/* I[fBIp֐ */
static void s_audio_process(const int32_t* p_rxbuf, int32_t* p_txbuf, int32_t count);

/* TWI(I2C)p֐ */
static void s_twi_init(void);
/* TWI(I2C)f[^Mp֐ */
static int32_t s_twi_master_write(uint8_t slave_addr, int32_t rstart, const uint8_t* p_data, int32_t write_cnt);

/* UART֐ */
static void s_uart_init(void);
/* UART1M */
static void s_uart_putc(char ch);
/* UART1sM */
static void s_uart_print(const char *p_buf);
/* UARTM荞݂̃vg^Cv錾 */
EX_INTERRUPT_HANDLER(s_uart_rx_isr);

/* GP^C}0荞݂̃vg^Cv錾 */
EX_INTERRUPT_HANDLER(s_gptimer_isr);

/* SPORTMobt@(_uobt@) */
static int32_t sf_sport_rxbuf[2][NUM_SAMPLES];
/* SPORTMobt@(_uobt@) */
static int32_t sf_sport_txbuf[2][NUM_SAMPLES];
/* DMAǂ̃obt@gpĂ邩 */
static volatile int32_t sf_sport_use_bufidx;

/* f[^]tO */
static volatile int32_t sf_data_incoming;

/* SSM2603 TWIf[^ */
static const uint8_t sf_audio_init_data[] =
{
	(0x0F << 1) | 0, 0x00,
	(0x00 << 1) | 1, 0x17,
	(0x01 << 1) | 1, 0x17,
	(0x02 << 1) | 1, 0x79,
	(0x03 << 1) | 1, 0x79,
	(0x04 << 1) | 0, 0x12,
	(0x05 << 1) | 0, 0x00,
	(0x06 << 1) | 0, 0x02,
	(0x07 << 1) | 0, 0x4E,
	(0x08 << 1) | 0, 0x01,
	(0x09 << 1) | 0, 0x01,
	(0x10 << 1) | 1, 0x8B,
	(0x12 << 1) | 0, 0x33,
};

/* 1msPʃJE^ */
static uint32_t sf_1ms_counter;

/* g[NX[0, 0ȊO */
static int32_t sf_mute_en;

static void s_bfin_clk_pll_set(uint8_t mul_val, uint8_t div_val)
{
	*pSIC_IWR = IWR_ENABLE(0);				/* PLL̂IWR */
	*pPLL_DIV = div_val;
	*pPLL_CTL = (mul_val) << 9;
	asm("cli r0; csync; idle; sti r0;": : :"R0");
	*pSIC_IWR = IWR_ENABLE_ALL;
}

/* w肳ꂽ}CNbҋ@ */
static void s_us_delay(uint32_t us)
{
	uint32_t l_start;
	uint32_t l_now;
	uint32_t l_stop = us * (uint32_t)(CCLOCK_HZ / 1000000);

	asm("%0 = CYCLES;" : "=d"(l_start));
	while(1)
	{
		asm volatile("%0 = CYCLES;" : "=d"(l_now));
		if((l_now - l_start) >= l_stop)
			break;
	}
}

static void s_codec_init(void)
{
	uint32_t l_lc;

	/* CODEC҂(100ms) */
	s_us_delay(100000);

	/* SSM2603 */
	for(l_lc = 0; l_lc < sizeof(sf_audio_init_data); l_lc += 2)
	{
		/* SSM2603WX^ݒ */
		s_twi_master_write(TWI_CODEC_DEVICE_ADDR, TWI_STOP, &sf_audio_init_data[l_lc], 2);
		s_us_delay(10000); /* 莞ԑҋ@ (̎ԂZƂ܂ZbgȂP[X)*/
	}
}

void main(void)
{
	int32_t  l_dmabuf_idx;
	
	/* VR_CTLݒ */
	/* EXTCLK_OE = 1, EXTCLK_SEL = 0 */
	*pVR_CTL = EXTCLK_OE | HIBERNATEB;

	/* PLLݒ */
	/* CCLK 12Mhz * 33 = 396MHz */
	/* SCLK CCLK / 4   =  99MHz */
	s_bfin_clk_pll_set(33, 4);

	/* obt@NA */
	memset(sf_sport_rxbuf, 0 , sizeof(sf_sport_rxbuf));
	memset(sf_sport_txbuf, 0 , sizeof(sf_sport_txbuf));
	sf_sport_use_bufidx = 0;
	sf_data_incoming = 0;
	sf_1ms_counter = 0;
	sf_mute_en = 0;
	
	/* |[g̐ݒ(SW) */
	*pPORTF_FER    &= ~PF0;
	*pPORTFIO_DIR  &= ~PF0;
	*pPORTFIO_INEN |=  PF0;
	
	/* |[g̐ݒ(LED) */
	*pPORTF_FER    &= ~PF4;
	*pPORTFIO_DIR  |=  PF4;
	*pPORTFIO_INEN &= ~PF4;
	*pPORTFIO_CLEAR =  PF4;
	
	/* |[g̐ݒ(SPORT1) */
	*pPORTF_MUX &= ~(PF1 | PF2 | PF3 | PF5 | PF6 | PF7); 
	*pPORTF_FER |= PF1 | PF2 | PF3 | PF5 | PF6 | PF7;

	/* UART */	
	s_uart_init();
    s_uart_print("\r\nTUNA-CAN audio talkthrough sample.\r\n");
    s_uart_print("Push the user switch to mute audio.\r\n");

	/* TWI */
	s_twi_init();
	/* SSM2603 */
	s_codec_init();
	
	/* GP^C}0̐ݒ */
	/* 1msPʂɊ荞݂悤ɐݒ */
	*pTIMER0_CONFIG = OUT_DIS | IRQ_ENA | PERIOD_CNT | PWM_OUT;
	*pTIMER0_PERIOD = SCLOCK_HZ / 1000;
	*pTIMER0_WIDTH = 1;
	*pTIMER_ENABLE = TIMEN0;
	/* 荞݃nhIVG11ɓo^ */
    register_handler(ik_ivg11, s_gptimer_isr);
	*pSIC_IMASK |= IRQ_TIMER0;

	/* SPORT RX̐ݒ */
	/* ONbNAOSYNCAMSB First */
	/* 24rbgf[^A XeI */
	*pSPORT1_RCR1 = RFSR | RCKFE;
	*pSPORT1_RCR2 = SLEN(31) | RSFSE;
	/* SPORT TX̐ݒ */
	/* ONbNAOSYNCAMSB First */
	/* 24rbgf[^A XeI */
	*pSPORT1_TCR1 = TFSR | TCKFE;
	*pSPORT1_TCR2 = SLEN(31) | TSFSE;

	/* DMA3(SPORT1 RX)̐ݒ */
	*pDMA3_PERIPHERAL_MAP = 0x3000;
	*pDMA3_CONFIG = FLOW_AUTO | DI_EN | DI_SEL | DMA2D | WDSIZE_32 | WNR;
	*pDMA3_START_ADDR = sf_sport_rxbuf;
	*pDMA3_X_COUNT = NUM_SAMPLES;
	*pDMA3_X_MODIFY = sizeof(int32_t);
	*pDMA3_Y_COUNT = 2;
	*pDMA3_Y_MODIFY = sizeof(int32_t);
	*pDMA3_IRQ_STATUS = DMA_DONE | DMA_ERR;

	/* DMA4(SPORT1 TX)̐ݒ */
	*pDMA4_PERIPHERAL_MAP = 0x4000;
	*pDMA4_CONFIG = FLOW_AUTO | DMA2D | WDSIZE_32;
	*pDMA4_START_ADDR = sf_sport_txbuf;
	*pDMA4_X_COUNT = NUM_SAMPLES;
	*pDMA4_X_MODIFY = sizeof(int32_t);
	*pDMA4_Y_COUNT = 2;
	*pDMA4_Y_MODIFY = sizeof(int32_t);
	*pDMA4_IRQ_STATUS = DMA_DONE | DMA_ERR;
	ssync();

	/* 荞݃nhIVG9ɓo^ */
    register_handler(ik_ivg9, s_sport_rx_isr);
	*pSIC_IMASK |= IRQ_DMA3;

	/* DMAL */
	*pDMA3_IRQ_STATUS = DMA_DONE;
	*pDMA3_CONFIG |= DMAEN;
	*pDMA4_CONFIG |= DMAEN;
	/* SPORT1L */
	*pSPORT1_TCR1 |= TSPEN;
	*pSPORT1_RCR1 |= RSPEN;
	ssync();

	while(1)
	{
		idle();
		if(0 != sf_data_incoming)
		{
			/* tONA */
			sf_data_incoming = 0;
			/* gpĂ悢obt@擾 */
			l_dmabuf_idx = sf_sport_use_bufidx ^ 1;
			s_audio_process(sf_sport_rxbuf[l_dmabuf_idx], sf_sport_txbuf[l_dmabuf_idx], NUM_SAMPLES);
		}
	}
}

void s_audio_process(const int32_t* p_rxbuf, int32_t* p_txbuf, int32_t count)
{
	if(sf_mute_en == 0)
	{
		/* Mobt@̃f[^𑗐Mobt@ɃRs[ */
		int32_t l_lc;
		for(l_lc = 0; l_lc < count; l_lc++)
		{
			p_txbuf[l_lc] = p_rxbuf[l_lc];
		}
	}
	else
	{
		/*  */
		memset(p_txbuf, 0, count * sizeof(int32_t));
	}
}

/* SPORT RX DMA荞݃nh */
EX_INTERRUPT_HANDLER(s_sport_rx_isr)
{
	*pDMA3_IRQ_STATUS = DMA_DONE;
	ssync();
	/* I[fBIR[fbNf[^ */
	sf_data_incoming = 1;
	/* DMAgpobt@ύX */
	sf_sport_use_bufidx = (sf_sport_use_bufidx ^ 1) & 1;
}

/* TWI(I2C) */
void s_twi_init(void)
{
	*pTWI_CONTROL = 0;
	ssync();
	*pTWI_CONTROL = TWI_ENA | 10U;
	*pTWI_CLKDIV  = CLKHI(8) | CLKLOW(17);
	*pTWI_INT_MASK = RCVSERV | XMTSERV | MERR | MCOMP;
	*pTWI_INT_STAT = *pTWI_INT_STAT;
	*pTWI_FIFO_CTL = XMTFLUSH | RCVFLUSH;
	ssync();
}

int32_t s_twi_master_write(uint8_t slave_addr, int32_t rstart, const uint8_t* p_data, int32_t write_cnt)
{
	int32_t l_idx;
	
	if(write_cnt <= 0)
	{
		return NO_ERROR;
	}

	*pTWI_FIFO_CTL = 0;
	*pTWI_INT_STAT = *pTWI_INT_STAT;
	*pTWI_MASTER_STAT = BUFWRERR | BUFRDERR | LOSTARB | ANAK | DNAK | FAST;
	*pTWI_MASTER_ADDR = slave_addr;
	// Send first byte
	*pTWI_XMT_DATA8 = p_data[0];
	*pTWI_MASTER_CTL = TWI_COUNT(write_cnt) | MEN | (rstart ? RSTART : 0);
	ssync();

	for(l_idx = 1; l_idx < write_cnt; l_idx++)
	{
		while(((*pTWI_INT_STAT & MERR) == 0U) && (*pTWI_FIFO_STAT == XMTSTAT)) ssync();
		*pTWI_XMT_DATA8 = p_data[l_idx];
		ssync();
	}

	/* ]I܂őҋ@ */
	while((*pTWI_INT_STAT & MCOMP) == 0U) ssync();
	if((*pTWI_INT_STAT & MERR) == 0U)
	{
		return NO_ERROR;
	}
	else
	{
		return TWI_ERROR_NAK;
	}
}

static void s_uart_init(void)
{
	/* PF11/PF12sUARTɊU */
    *pPORTF_MUX &= ~(PF11 | PF12);	/* PF11,PF120ɂ */
    *pPORTF_FER |= PF11 | PF12;		/* PF11,PF12UART0ɊU */

	/* UARTCl[u */
	*pUART0_GCTL = 1;

	/* UART̐ݒ */
	*pUART0_LCR |= DLAB;
	*pUART0_DLL = UART0_DIVISOR & 0xFF;
	*pUART0_DLH = UART0_DIVISOR >> 8;
	*pUART0_LCR &= ~DLAB;

	/* UART[hݒ peB 8bit 1Xgbvrbg */
	*pUART0_LCR = WLS(8);

	/* 荞݃nhIVG10ɓo^ */
    register_handler(ik_ivg10, s_uart_rx_isr);
	/* UARTM݂ */
	*pUART0_IER = ERBFI;
	*pSIC_IMASK |= IRQ_DMA7;	/* DMA7 = UART RX */	
}

static void s_uart_putc(char ch)
{
	/* UART0 LSRTHRE1ɂȂ܂ő҂B1ȂΑMWX^ */
	while(0 == (*pUART0_LSR & THRE)) ssync();
	*pUART0_THR = ch;	/* ꕶM */
	ssync();
}

static void s_uart_print(const char *p_buf)
{
	int l_lc;
	int l_len = strlen(p_buf);
	
	for(l_lc = 0; l_lc < l_len; l_lc++)
	{
		s_uart_putc(p_buf[l_lc]);	/* ꕶM */
	}
}

EX_INTERRUPT_HANDLER(s_uart_rx_isr)
{
	/* Mf[^̂܂ܑM */
	*pUART0_THR = *pUART0_RBR;
	ssync();
}

EX_INTERRUPT_HANDLER(s_gptimer_isr)
{
	static uint32_t l_1ms_cnt = 0;
	/* XCb`̏ */
	static uint16_t l_sw_state = 0;
	static uint16_t l_sw_sample = 0;
	uint16_t l_sw_state_prev;
	uint16_t l_sw_sample_prev;
	uint16_t l_sw_change_bit;

	/* 荞݃Xe[^X̍XV */
	*pTIMER_STATUS = TIMIL0;
	ssync();
	
	/* JE^CNg */
	sf_1ms_counter++;

	/* 10msɃXCb`̏Ԃ`FbN */
	if((int32_t)(sf_1ms_counter - l_1ms_cnt) > 10)
	{
		/* ÕTvOԂۑ */
		l_sw_sample_prev = l_sw_sample;
		l_sw_state_prev  = l_sw_state;
		/* XCb`̏ԂTv */
		l_sw_sample = ~*pPORTFIO & PF0;
		/* XCb`̏ԂXV */
		l_sw_state  = l_sw_sample & ~(l_sw_sample ^ l_sw_sample_prev);
		/* ω̂rbg擾 */
		l_sw_change_bit = l_sw_state ^ l_sw_state_prev;

		/* XCb`̏ԂɍďLEDω */
		if((l_sw_change_bit & PF0) && (l_sw_state & PF0))
		{
			sf_mute_en = !sf_mute_en;
			if(sf_mute_en == 0)
				*pPORTFIO_CLEAR = PF4;
			else
				*pPORTFIO_SET = PF4;
		}

		l_1ms_cnt = sf_1ms_counter;
	}
}

